      .386
      .model flat, stdcall  ; 32 bit memory model
      option casemap :none  ; case sensitive

;**********************************************************************
;     include files
;**********************************************************************     
      include \Altra32\INCLUDE\windows.inc
      include \Altra32\INCLUDE\user32.inc
      include \Altra32\INCLUDE\kernel32.inc
      include \Altra32\INCLUDE\comdlg32.inc
      include \Altra32\include\Comctl32.inc
      include \Altra32\include\gdi32.inc

;**********************************************************************
;     libraries
;**********************************************************************
      includelib \Altra32\LIB\user32.lib
      includelib \Altra32\LIB\kernel32.lib
      includelib \Altra32\LIB\comdlg32.lib
      includelib \Altra32\lib\Comctl32.lib
      includelib \Altra32\lib\gdi32.lib

;**********************************************************************
; Local prototypes
;**********************************************************************
        WinMain                 PROTO :DWORD
        DrawClientbox           PROTO :DWORD,:DWORD,:DWORD
        WinProc                 PROTO :DWORD,:DWORD,:DWORD,:DWORD
        wsprintfA               PROTO C :DWORD,:VARARG

        wsprintf equ <wsprintfA>

;**********************************************************************
; Local macros
;**********************************************************************
include macros.asm

;**********************************************************************
; Place all your Constance here.
;**********************************************************************
.const
ICO_MAINICON     equ 500

;**********************************************************************
; Inishilized DATA
;**********************************************************************
.data
MouseDown        dd 0
holdrect         RECT<>                  
lastrect         RECT<>
hBitmap          dd 0
Wwidth           dd 350
Wheight          dd 315
szClassName      db "Template_Class",0
szAppName        db "Template",0

;**********************************************************************
; Un-Inishilized DATA
;**********************************************************************
.data?
hWnd             dd ?
hInstance        dd ?
hIcon            dd ?
mousept          POINT<>
old_mousept      POINT<>
mouserect        RECT<>
.code
;**********************************************************************
; This is the start of the code section, here we get our Module Handle
; and start our Program.
;**********************************************************************
start:
      mov hInstance,FUNC(GetModuleHandle,NULL)
      invoke WinMain,hInstance 
      invoke ExitProcess,eax

;**********************************************************************
; This section creates the MAIN CLASS and the MAIN window.
; Then loops sending messages to our WinProc for Proccessing.
;**********************************************************************
WinMain proc hModule:DWORD

        LOCAL wc   :WNDCLASSEX
        LOCAL msg  :MSG

      mov hIcon,FUNC(LoadIcon,hModule,ICO_MAINICON)    ; icon ID
      mov wc.cbSize,sizeof WNDCLASSEX
      mov wc.style,CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
      mov wc.lpfnWndProc,offset WinProc
      mov wc.cbClsExtra,NULL
      mov wc.cbWndExtra,NULL
      m2m wc.hInstance,hModule
      mov wc.hbrBackground,COLOR_BTNFACE+1
      mov wc.lpszMenuName,NULL
      mov wc.lpszClassName,offset szClassName
      m2m wc.hIcon,hIcon
      mov wc.hCursor,FUNC(LoadCursor,NULL,IDC_ARROW)
      m2m wc.hIconSm,hIcon
      invoke RegisterClassEx, addr wc
      mov hWnd,FUNC(CreateWindowEx,WS_EX_LEFT,addr szClassName,addr szAppName,WS_SIZEBOX or WS_CAPTION or WS_SYSMENU or WS_MINIMIZEBOX or WS_MAXIMIZEBOX or WS_POPUP or WS_VISIBLE or WS_BORDER or WS_DLGFRAME,10,10,Wwidth,Wheight,NULL,NULL,hModule,NULL)
      invoke ShowWindow,hWnd,SW_SHOWNORMAL
      invoke UpdateWindow,hWnd
      MSGLOOP msg
WinMain endp
;**********************************************************************
; This is the Main programs code area. all messages for this APP are
; recived here, or the main app.
;**********************************************************************
WinProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

        LOCAL rect      :RECT

          .if uMsg == WM_CREATE



          .elseif uMsg == WM_LBUTTONDOWN
                  mov MouseDown,1
                  invoke SetCapture,hWin
                  invoke GetCursorPos,addr mousept
                  invoke ScreenToClient,hWin,addr mousept
                  mov eax,[mousept.x]
                  mov [mouserect.left],eax
                  mov [mouserect.right],eax
                  mov eax,[mousept.y]
                  mov [mouserect.top],eax
                  mov [mouserect.bottom],eax
                  invoke DrawClientbox,hWin,addr mouserect,0

          .elseif uMsg == WM_LBUTTONUP
                  invoke DrawClientbox,hWin,addr mouserect,0
                  mov MouseDown,0
                  invoke ReleaseCapture

          .elseif uMsg == WM_MOUSEMOVE
            .if MouseDown == 1
                invoke DrawClientbox,hWin,addr mouserect,2
                invoke GetCursorPos,addr mousept
                invoke ScreenToClient,hWin,addr mousept
                mov eax,[mousept.x]
                mov [mouserect.right],eax
                mov eax,[mousept.y]
                mov [mouserect.bottom],eax
            .endif
            .if wParam == MK_LBUTTON
                invoke DrawClientbox,hWin,addr mouserect,0
            .endif



          .elseif uMsg == WM_CLOSE
                  invoke DestroyIcon,hIcon
                  invoke DestroyWindow,hWin

          .elseif uMsg == WM_DESTROY
                  invoke PostQuitMessage,0
                  return 0
          .endif


          invoke DefWindowProc,hWin,uMsg,wParam,lParam
          ret
WinProc endp
;**************************************************************************
;
;
;**************************************************************************
DrawClientbox proc uses esi hWin:DWORD,lpRect:DWORD,nFun:DWORD
                  LOCAL Xsize     :DWORD
                  LOCAL Ysize     :DWORD
                  LOCAL Xlastsize :DWORD
                  LOCAL Ylastsize :DWORD
                  LOCAL hDC       :DWORD
                  LOCAL hPen      :DWORD
                  LOCAL hMemDC    :DWORD
                  LOCAL hBrush    :DWORD
                  LOCAL OldObject :DWORD
                  LOCAL rect:RECT
                  LOCAL color     :DWORD

            invoke GetModuleHandle,0
            mov [hInstance],eax
            invoke CopyRect,addr rect,lpRect
            mov eax,[rect.bottom]
            sub eax,[rect.top]
            mov [Ysize],eax
            mov eax,[rect.right]
            sub eax,[rect.left]
            mov [Xsize],eax
            mov eax,[lastrect.bottom]
            sub eax,[lastrect.top]
            mov [Ylastsize],eax
            mov eax,[lastrect.right]
            sub eax,[lastrect.left]
            mov [Xlastsize],eax
            invoke GetDC,hWin
            mov [hDC],eax
            invoke CreateCompatibleDC,hDC
            mov [hMemDC],eax 
            invoke CreateCompatibleBitmap,hDC,1280,1024
            mov [hBitmap],eax
            invoke SelectObject,hMemDC,hBitmap
            mov OldObject,eax
            invoke CreateSolidBrush,0h
            mov [hBrush],eax
            invoke FillRect,hMemDC,addr rect,hBrush
            
            .if nFun == 0
            sub [Xsize],4
            add [rect.left],2
            invoke BitBlt,hDC,rect.left,rect.top,[Xsize],2,hMemDC,0,0,PATINVERT
            sub [rect.left],2
            invoke BitBlt,hDC,rect.left,rect.top,2,Ysize,hMemDC,0,0,PATINVERT

            mov eax,[rect.bottom]
            sub eax,2
            mov [rect.top],eax   
            add [rect.left],2         
            invoke BitBlt,hDC,rect.left,rect.top,[Xsize],2,hMemDC,0,0,PATINVERT
            invoke CopyRect,addr rect,lpRect
            

            
            mov eax,[rect.right]
            sub eax,2
            mov [rect.left],eax
            invoke BitBlt,hDC,rect.left,rect.top,2,Ysize,hMemDC,0,0,PATINVERT
            invoke CopyRect,addr rect,lpRect
            add [Xsize],2
            
            invoke CopyRect,addr lastrect,addr rect
            jmp End_Draw
            .endif
            
            .if nFun == 1
            invoke CopyRect,addr holdrect,addr lastrect
            sub [Xlastsize],4
            sub [Xsize],4

            mov eax,[lastrect.bottom]
            sub eax,2
            mov [lastrect.top],eax
            add [lastrect.left],2            
            invoke BitBlt,hDC,lastrect.left,lastrect.top,[Xlastsize],2,hMemDC,0,0,PATINVERT
            invoke CopyRect,addr lastrect,addr holdrect
            
            mov eax,[lastrect.right]
            sub eax,2
            mov [lastrect.left],eax
            invoke BitBlt,hDC,lastrect.left,lastrect.top,2,Ylastsize,hMemDC,0,0,PATINVERT
            invoke CopyRect,addr lastrect,addr holdrect


            add [lastrect.left],2
            invoke BitBlt,hDC,lastrect.left,lastrect.top,[Xlastsize],2,hMemDC,0,0,PATINVERT
            sub [lastrect.left],2
            invoke BitBlt,hDC,lastrect.left,lastrect.top,2,Ylastsize,hMemDC,0,0,PATINVERT



            mov eax,[rect.right]
            sub eax,2
            mov [rect.left],eax
            invoke BitBlt,hDC,rect.left,rect.top,2,Ysize,hMemDC,0,0,PATINVERT
            invoke CopyRect,addr rect,lpRect

            mov eax,[rect.bottom]
            sub eax,2
            mov [rect.top],eax  
            add [rect.left],2          
            invoke BitBlt,hDC,rect.left,rect.top,[Xsize],2,hMemDC,0,0,PATINVERT
            invoke CopyRect,addr rect,lpRect


            add [rect.left],2
            invoke BitBlt,hDC,rect.left,rect.top,[Xsize],2,hMemDC,0,0,PATINVERT
            sub [rect.left],2
            invoke BitBlt,hDC,rect.left,rect.top,2,Ysize,hMemDC,0,0,PATINVERT
            add [Xlastsize],4
            add [Xsize],4


            invoke CopyRect,addr lastrect,addr rect
            jmp End_Draw
            .endif
            
            .if nFun == 2   
            sub [Xsize],4
            add [rect.left],2
            invoke BitBlt,hDC,rect.left,rect.top,[Xsize],2,hMemDC,0,0,PATINVERT
            sub [rect.left],2
            
            invoke BitBlt,hDC,rect.left,rect.top,2,Ysize,hMemDC,0,0,PATINVERT
            invoke CopyRect,addr rect,lpRect

            mov eax,[rect.bottom]
            sub eax,2
            mov [rect.top],eax  
            add [rect.left],2
            invoke BitBlt,hDC,rect.left,rect.top,[Xsize],2,hMemDC,0,0,PATINVERT
            invoke CopyRect,addr rect,lpRect
            
            mov eax,[rect.right]
            sub eax,2
            mov [rect.left],eax
            invoke BitBlt,hDC,rect.left,rect.top,2,Ysize,hMemDC,0,0,PATINVERT
            invoke CopyRect,addr rect,lpRect
            add [Xsize],4                     
            .endif
End_Draw:            
            invoke DeleteObject,hBrush
            invoke SelectObject,hMemDC,OldObject
            mov hBitmap,eax
            invoke DeleteDC,hMemDC
            invoke DeleteObject,hBitmap
            invoke ReleaseDC,hWin,hDC
	        ret

DrawClientbox endp

end start
